/******************************************************************************/
/*                                                                            */
/*  Cedocida DV-Codec                                                         */
/*                                                                            */
/*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              */
/*  Project start: 15.12.2003                                                 */
/*  Last change  : 15.06.2007                                                 */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  This program is free software; you can redistribute it and/or modify      */
/*  it under the terms of the GNU General Public License as published by      */
/*  the Free Software Foundation; either version 2 of the License, or         */
/*  (at your option) any later version.                                       */
/*                                                                            */
/*  This program is distributed in the hope that it will be useful,           */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/*  GNU General Public License for more details.                              */
/*                                                                            */
/*  You should have received a copy of the GNU General Public License         */
/*  along with this program; if not, write to the Free Software               */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                            */
/******************************************************************************/

#define CONFIGURATION_FILENAME L"cedocida.ini"

#define COLORFORMAT_YV12	1
#define COLORFORMAT_YUY2	2
#define COLORFORMAT_RGB32	4
#define COLORFORMAT_RGB24	8
#define COLORFORMAT_UNKNOWN	-1
#define COLORFORMAT_NA      -2


#define RGB2YUV_601			0
#define RGB2YUV_UNCHANGED	1

#define YV12_CHROMASAMPLING_DV			0
#define YV12_CHROMASAMPLING_MPEG2_I		1
#define YV12_CHROMASAMPLING_MPEG2_P		2

typedef struct {
	int id;
	int encoder_quality_mode;
	int encoder_input_format;
	int encoder_RGB_to_YUV_conversion;
	int encoder_YV12_chroma_sampling;
	int encoder_dct248_threshold;
	int encoder_dct248_counts;
	int encoder_coring_enable;
	int16_t encoder_coring_matrix[64];
	int encoder_classification_Y[3];
	int encoder_classification_V[3];
	int encoder_classification_U[3];
	int decoder_output_format;
	int decoder_YUV_to_RGB_conversion;
	int decoder_YV12_chroma_sampling;
} configvars_t;



#define NO_OF_QUALITY_MODES 2
#define QUALITY_MODE_NORMAL 0
#define QUALITY_MODE_FAST 1



int load_configuration( configvars_t *lpmyconfig );

int save_configuration( configvars_t *lpmyconfig );

