;******************************************************************************/
;*                                                                            */
;*  Cedocida DV-Codec                                                         */
;*                                                                            */
;*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              */
;*  Project start: 15.12.2003                                                 */
;*  Last change  : 08.05.2005                                                 */
;*                                                                            */
;******************************************************************************/
;*                                                                            */
;*  This program is free software; you can redistribute it and/or modify      */
;*  it under the terms of the GNU General Public License as published by      */
;*  the Free Software Foundation; either version 2 of the License, or         */
;*  (at your option) any later version.                                       */
;*                                                                            */
;*  This program is distributed in the hope that it will be useful,           */
;*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
;*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
;*  GNU General Public License for more details.                              */
;*                                                                            */
;*  You should have received a copy of the GNU General Public License         */
;*  along with this program; if not, write to the Free Software               */
;*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
;*                                                                            */
;******************************************************************************/

BITS 32

%macro cglobal 1
	%ifdef PREFIX
		global _%1
		%define %1 _%1
	%else
		global %1
	%endif
%endmacro


;=============================================================================
; Read only data
;=============================================================================

%ifdef FORMAT_COFF
SECTION .rodata data
%else
SECTION .rodata data align=16
%endif

ALIGN 16
DCT_table:
;fTab1:
  dw 0x4000, 0x4000, 0x58c5, 0x4b42
  dw 0x4000, 0x4000, 0x3249, 0x11a8
  dw 0x539f, 0x22a3, 0x4b42, 0xee58
  dw 0xdd5d, 0xac61, 0xa73b, 0xcdb7
  dw 0x4000, 0xc000, 0x3249, 0xa73b
  dw 0xc000, 0x4000, 0x11a8, 0x4b42
  dw 0x22a3, 0xac61, 0x11a8, 0xcdb7
  dw 0x539f, 0xdd5d, 0x4b42, 0xa73b

;fTab2:
  dw 0x58c5, 0x58c5, 0x7b21, 0x6862
  dw 0x58c5, 0x58c5, 0x45bf, 0x187e
  dw 0x73fc, 0x300b, 0x6862, 0xe782
  dw 0xcff5, 0x8c04, 0x84df, 0xba41
  dw 0x58c5, 0xa73b, 0x45bf, 0x84df
  dw 0xa73b, 0x58c5, 0x187e, 0x6862
  dw 0x300b, 0x8c04, 0x187e, 0xba41
  dw 0x73fc, 0xcff5, 0x6862, 0x84df

;fTab3:
  dw 0x539f, 0x539f, 0x73fc, 0x6254
  dw 0x539f, 0x539f, 0x41b3, 0x1712
  dw 0x6d41, 0x2d41, 0x6254, 0xe8ee
  dw 0xd2bf, 0x92bf, 0x8c04, 0xbe4d
  dw 0x539f, 0xac61, 0x41b3, 0x8c04
  dw 0xac61, 0x539f, 0x1712, 0x6254
  dw 0x2d41, 0x92bf, 0x1712, 0xbe4d
  dw 0x6d41, 0xd2bf, 0x6254, 0x8c04

;fTab4:
  dw 0x4b42, 0x4b42, 0x6862, 0x587e
  dw 0x4b42, 0x4b42, 0x3b21, 0x14c3
  dw 0x6254, 0x28ba, 0x587e, 0xeb3d
  dw 0xd746, 0x9dac, 0x979e, 0xc4df
  dw 0x4b42, 0xb4be, 0x3b21, 0x979e
  dw 0xb4be, 0x4b42, 0x14c3, 0x587e
  dw 0x28ba, 0x9dac, 0x14c3, 0xc4df
  dw 0x6254, 0xd746, 0x587e, 0x979e

;fTab1:
  dw 0x4000, 0x4000, 0x58c5, 0x4b42
  dw 0x4000, 0x4000, 0x3249, 0x11a8
  dw 0x539f, 0x22a3, 0x4b42, 0xee58
  dw 0xdd5d, 0xac61, 0xa73b, 0xcdb7
  dw 0x4000, 0xc000, 0x3249, 0xa73b
  dw 0xc000, 0x4000, 0x11a8, 0x4b42
  dw 0x22a3, 0xac61, 0x11a8, 0xcdb7
  dw 0x539f, 0xdd5d, 0x4b42, 0xa73b

;fTab4:
  dw 0x4b42, 0x4b42, 0x6862, 0x587e
  dw 0x4b42, 0x4b42, 0x3b21, 0x14c3
  dw 0x6254, 0x28ba, 0x587e, 0xeb3d
  dw 0xd746, 0x9dac, 0x979e, 0xc4df
  dw 0x4b42, 0xb4be, 0x3b21, 0x979e
  dw 0xb4be, 0x4b42, 0x14c3, 0x587e
  dw 0x28ba, 0x9dac, 0x14c3, 0xc4df
  dw 0x6254, 0xd746, 0x587e, 0x979e

;fTab3:
  dw 0x539f, 0x539f, 0x73fc, 0x6254
  dw 0x539f, 0x539f, 0x41b3, 0x1712
  dw 0x6d41, 0x2d41, 0x6254, 0xe8ee
  dw 0xd2bf, 0x92bf, 0x8c04, 0xbe4d
  dw 0x539f, 0xac61, 0x41b3, 0x8c04
  dw 0xac61, 0x539f, 0x1712, 0x6254
  dw 0x2d41, 0x92bf, 0x1712, 0xbe4d
  dw 0x6d41, 0xd2bf, 0x6254, 0x8c04

;fTab2:
  dw 0x58c5, 0x58c5, 0x7b21, 0x6862
  dw 0x58c5, 0x58c5, 0x45bf, 0x187e
  dw 0x73fc, 0x300b, 0x6862, 0xe782
  dw 0xcff5, 0x8c04, 0x84df, 0xba41
  dw 0x58c5, 0xa73b, 0x45bf, 0x84df
  dw 0xa73b, 0x58c5, 0x187e, 0x6862
  dw 0x300b, 0x8c04, 0x187e, 0xba41
  dw 0x73fc, 0xcff5, 0x6862, 0x84df


DCT_248_table:
;fTab1:
  dw 0x4000, 0x4000, 0x58c5, 0x4b42
  dw 0x4000, 0x4000, 0x3249, 0x11a8
  dw 0x539f, 0x22a3, 0x4b42, 0xee58
  dw 0xdd5d, 0xac61, 0xa73b, 0xcdb7
  dw 0x4000, 0xc000, 0x3249, 0xa73b
  dw 0xc000, 0x4000, 0x11a8, 0x4b42
  dw 0x22a3, 0xac61, 0x11a8, 0xcdb7
  dw 0x539f, 0xdd5d, 0x4b42, 0xa73b

;fTab3:
  dw 0x539f, 0x539f, 0x73fc, 0x6254
  dw 0x539f, 0x539f, 0x41b3, 0x1712
  dw 0x6d41, 0x2d41, 0x6254, 0xe8ee
  dw 0xd2bf, 0x92bf, 0x8c04, 0xbe4d
  dw 0x539f, 0xac61, 0x41b3, 0x8c04
  dw 0xac61, 0x539f, 0x1712, 0x6254
  dw 0x2d41, 0x92bf, 0x1712, 0xbe4d
  dw 0x6d41, 0xd2bf, 0x6254, 0x8c04


weight_88:
  dw 	 16384,  32138,  30274,  29490,  28672,  27867,  25080,  23624
  dw 	 32138,  31521,  29692,  28924,  28121,  27331,  24598,  23170
  dw 	 30274,  29692,  27969,  27246,  26489,  25746,  23170,  21826
  dw 	 29490,  28924,  27246,  26541,  25804,  25080,  22571,  21261
  dw 	 28672,  28121,  26489,  25804,  25088,  24384,  21945,  20671
  dw 	 27867,  27331,  25746,  25080,  24384,  23699,  21328,  20091
  dw 	 25080,  24598,  23170,  22571,  21945,  21328,  19195,  18081
  dw 	 23624,  23170,  21826,  21261,  20671,  20091,  18081,  17032


weight_248:
  dw 	 16384,  32138,  30274,  29490,  28672,  27867,  25080,  23624
  dw 	 30274,  29692,  27969,  27246,  26489,  25746,  23170,  21826
  dw 	 28672,  28121,  26489,  25804,  25088,  24384,  21945,  20671
  dw 	 25080,  24598,  23170,  22571,  21945,  21328,  19195,  18081
  dw 	 32767,  32138,  30274,  29490,  28672,  27867,  25080,  23624
  dw 	 30274,  29692,  27969,  27246,  26489,  25746,  23170,  21826
  dw 	 28672,  28121,  26489,  25804,  25088,  24384,  21945,  20671
  dw 	 25080,  24598,  23170,  22571,  21945,  21328,  19195,  18081


tan1:
	dw  0x32ec,0x32ec,0x32ec,0x32ec    ; tan( pi/16)
tan2:
	dw  0x6a0a,0x6a0a,0x6a0a,0x6a0a    ; tan(2pi/16)  (=sqrt(2)-1)
tan3:
	dw  0xab0e,0xab0e,0xab0e,0xab0e    ; tan(3pi/16)-1
sqrt2:
	dw  0x5a82,0x5a82,0x5a82,0x5a82    ; 0.5/sqrt(2)

%define w_tan8 27146
pw_tan8:
  dw w_tan8,w_tan8,w_tan8,w_tan8

pw_one:
  dw 1, 1, 1, 1

pw_correction:
  dw 8, 0, 0, 0


;=============================================================================
; Code
;=============================================================================

SECTION .text


;-----------------------------------------------------------------------------
; extern "C" void dct_88_weighted_mmx_ad( short *in, short *out );
;-----------------------------------------------------------------------------
%define DCT_MMX_ROW_SHIFT_1 17

cglobal dct_88_weighted_mmx_ad

ALIGN 16
dct_88_weighted_mmx_ad:
; in and out can be the same adress!
	mov eax, [esp+4]		; in
	mov ecx, [esp+8]		; out

; col 1
	movq mm0, [eax+0*16]   ; In0
	movq mm2, [eax+2*16]   ; In2
	movq mm3, mm0
	movq mm7, [eax+7*16]   ; In7
	movq mm4, mm2

	psubsw mm0, mm7       ; t7 = In0-In7
	movq mm5, [eax+5*16]   ; In5
	paddsw mm7, mm3       ; t0 = In0+In7
	movq mm3, [eax+3*16]   ; In3
	psubsw mm2, mm5       ; t5 = In2-In5
	movq mm1, mm3
	paddsw mm5, mm4       ; t2 = In2+In5

	movq mm4, [eax+4*16]   ; In4
	psubsw mm3, mm4       ; t4 = In3-In4
	paddsw mm4, mm1       ; t3 = In3+In4
	movq mm6, [eax+6*16]   ; In6
	psubsw mm7, mm4       ; tm03 = t0-t3
	movq mm1, [eax+1*16]   ; In1
	psubsw mm1, mm6       ; t6 = In1-In6
	paddsw mm6, [eax+1*16] ; t1 = In1+In6

	paddsw mm4, mm4       ; 2.t3
	psubsw mm6, mm5       ; tm12 = t1-t2
	paddsw mm5, mm5       ; 2.t2
	paddsw mm4, mm7       ; tp03 = t0+t3

	psllw mm2, 1       ; shift t5 (shift +1 to..
	paddsw mm5, mm6       ; tp12 = t1+t2

	psllw mm1, 1       ; shift t6  ..compensate cos4/2)

	psubsw mm4, mm5       ; out4 = tp03-tp12
	paddsw mm5, mm5
	psubsw mm1, mm2       ; mm1: t6-t5
	paddsw mm5, mm4       ; out0 = tp03+tp12
	movq [ecx+4*16], mm4   ; => out4
	paddsw mm2, mm2
	movq [ecx+0*16], mm5   ; => out0

	movq mm4, [tan2]      ; mm4 <= tan2
	paddsw mm2, mm1       ; mm2: t6+t5
	pmulhw mm4, mm7       ; tm03*tan2
	movq mm5, [tan2]      ; mm5 <= tan2
	psubsw mm4, mm6       ; out6 = tm03*tan2 - tm12
	pmulhw mm5, mm6       ; tm12*tan2
	movq mm6, [sqrt2]
	paddsw mm5, mm7       ; out2 = tm12*tan2 + tm03

	movq mm7, [pw_one]

	pmulhw mm2, mm6       ; mm2: tp65 = (t6 + t5)*cos4
	por mm5, mm7          ; correct out2
	por mm4, mm7          ; correct out6
	pmulhw mm1, mm6       ; mm1: tm65 = (t6 - t5)*cos4

	movq [ecx+2*16], mm5   ; => out2
	por mm2, mm7          ; correct tp65
	movq mm5, mm3         ; save t4
	movq [ecx+6*16], mm4   ; => out6
	psubsw mm3, mm1       ; mm3: tm465 = t4 - tm65
	movq mm4, mm0         ; save t7

	psubsw mm0, mm2       ; mm0: tm765 = t7 - tp65
	movq mm7, mm3         ; save tm465
	paddsw mm2, mm4       ; mm2: tp765 = t7 + tp65
	movq mm4, [tan3]      ; tan3 - 1
	paddsw mm1, mm5       ; mm1: tp465 = t4 + tm65

	movq mm5, [tan1]      ; tan1

	pmulhw mm3, mm4       ; tm465*(tan3-1)
	movq mm6, mm1         ; save tp465
	pmulhw mm1, mm5       ; tp465*tan1

	paddsw mm3, mm7       ; tm465*tan3
	pmulhw mm4, mm0       ; tm765*(tan3-1)
	paddsw mm1, mm2       ; out1 = tp765 + tp465*tan1
	paddsw mm4, mm0       ; tm765*tan3
	pmulhw mm5, mm2       ; tp765*tan1

	movq mm2, [eax+8+2*16]   ; In2
	psubsw mm0, mm3       ; out3 = tm765 - tm465*tan3
	movq [ecx+1*16], mm1   ; => out1
	paddsw mm7, mm4       ; out5 = tm465 + tm765*tan3
	movq [ecx+3*16], mm0   ; => out3
	psubsw mm5, mm6       ; out7 =-tp465 + tp765*tan1

	movq [ecx+5*16], mm7   ; => out5
	movq [ecx+7*16], mm5   ; => out7

; col 2
	movq mm0, [eax+8+0*16]   ; In0
	movq mm3, mm0
	movq mm7, [eax+8+7*16]   ; In7
	movq mm4, mm2
	psubsw mm0, mm7       ; t7 = In0-In7
	movq mm5, [eax+8+5*16]   ; In5

	paddsw mm7, mm3       ; t0 = In0+In7
	movq mm3, [eax+8+3*16]   ; In3
	psubsw mm2, mm5       ; t5 = In2-In5
	movq mm1, mm3
	paddsw mm5, mm4       ; t2 = In2+In5

	movq mm4, [eax+8+4*16]   ; In4
	psubsw mm3, mm4       ; t4 = In3-In4
	paddsw mm4, mm1       ; t3 = In3+In4
	movq mm6, [eax+8+6*16]   ; In6
	psubsw mm7, mm4       ; tm03 = t0-t3
	movq mm1, [eax+8+1*16]   ; In1
	psubsw mm1, mm6       ; t6 = In1-In6
	paddsw mm6, [eax+8+1*16] ; t1 = In1+In6

	paddsw mm4, mm4       ; 2.t3
	psubsw mm6, mm5       ; tm12 = t1-t2
	paddsw mm5, mm5       ; 2.t2
	paddsw mm4, mm7       ; tp03 = t0+t3

	psllw mm2, 1       ; shift t5 (shift +1 to..
	paddsw mm5, mm6       ; tp12 = t1+t2

	psllw mm1, 1       ; shift t6  ..compensate cos4/2)

	psubsw mm4, mm5       ; out4 = tp03-tp12
	paddsw mm5, mm5
	psubsw mm1, mm2       ; mm1: t6-t5
	paddsw mm5, mm4       ; out0 = tp03+tp12
	movq [ecx+8+4*16], mm4   ; => out4
	paddsw mm2, mm2

	movq mm4, [tan2]      ; mm4 <= tan2
	paddsw mm2, mm1       ; mm2: t6+t5
	movq [ecx+8+0*16], mm5   ; => out0
	pmulhw mm4, mm7       ; tm03*tan2
	movq mm5, [tan2]      ; mm5 <= tan2
	psubsw mm4, mm6       ; out6 = tm03*tan2 - tm12
	pmulhw mm5, mm6       ; tm12*tan2
	movq mm6, [sqrt2]
	paddsw mm5, mm7       ; out2 = tm12*tan2 + tm03

	movq mm7, [pw_one]

	pmulhw mm2, mm6       ; mm2: tp65 = (t6 + t5)*cos4
	por mm5, mm7          ; correct out2
	por mm4, mm7          ; correct out6
	pmulhw mm1, mm6       ; mm1: tm65 = (t6 - t5)*cos4

	movq [ecx+8+2*16], mm5   ; => out2
	por mm2, mm7          ; correct tp65
	movq mm5, mm3         ; save t4
	movq [ecx+8+6*16], mm4   ; => out6
	psubsw mm3, mm1       ; mm3: tm465 = t4 - tm65
	movq mm4, mm0         ; save t7

	psubsw mm0, mm2       ; mm0: tm765 = t7 - tp65
	movq mm7, mm3         ; save tm465
	paddsw mm2, mm4       ; mm2: tp765 = t7 + tp65
	movq mm4, [tan3]      ; tan3 - 1
	paddsw mm1, mm5       ; mm1: tp465 = t4 + tm65

	movq mm5, [tan1]      ; tan1

	pmulhw mm3, mm4       ; tm465*(tan3-1)
	movq mm6, mm1         ; save tp465
	pmulhw mm1, mm5       ; tp465*tan1

	paddsw mm3, mm7       ; tm465*tan3
	pmulhw mm5, mm2       ; tp765*tan1
	paddsw mm1, mm2       ; out1 = tp765 + tp465*tan1
	pmulhw mm4, mm0       ; tm765*(tan3-1)
	movq [ecx+8+1*16], mm1   ; => out1
	paddsw mm4, mm0       ; tm765*tan3

	psubsw mm0, mm3       ; out3 = tm765 - tm465*tan3
	paddsw mm7, mm4       ; out5 = tm465 + tm765*tan3
	movq [ecx+8+3*16], mm0   ; => out3
	psubsw mm5, mm6       ; out7 =-tp465 + tp765*tan1

	movq [ecx+8+5*16], mm7   ; => out5
	movq [ecx+8+7*16], mm5   ; => out7


; now, row processing
; row 0,2,4,6

	movd mm1, [ecx + 8 + 4]     ; [67..]
	lea eax, [weight_88]
	movq mm0, [ecx + 0]         ; mm0 = [0123]
	lea edx, [DCT_table]
	movq mm7, mm0
	punpcklwd mm1, [ecx + 8]      ; [6475]
	movq mm2, mm1
	psrlq mm1, 32                ; [75..]
	punpcklwd mm1,mm2            ; [7654]

	paddsw mm0, mm1              ; mm0 = [a0 a1 a2 a3]
	psubsw mm7, mm1              ; mm7 = [b0 b1 b2 b3]

	movq mm1, mm0
	punpckldq mm0, mm7           ; mm0 = [a0 a1 b0 b1]
	punpckhdq mm1, mm7           ; mm1 = [b2 b3 a2 a3]

	movq mm2, qword [edx + 0]     ;  [   M00    M01      M16    M17]
	movq mm3, qword [edx + 8]     ;  [   M02    M03      M18    M19]
	pmaddwd mm2, mm0             ;  [a0.M00+a1.M01 | b0.M16+b1.M17]
	movq mm4, qword [edx + 16]    ;  [   M04    M05      M20    M21]
	pmaddwd mm3, mm1             ;  [a2.M02+a3.M03 | b2.M18+b3.M19]
	movq mm5, qword [edx + 24]    ;  [   M06    M07      M22    M23]
	pmaddwd mm4, mm0             ;  [a0.M04+a1.M05 | b0.M20+b1.M21]
	movq mm6, qword [edx + 32]    ;  [   M08    M09      M24    M25]
	pmaddwd mm5, mm1             ;  [a2.M06+a3.M07 | b2.M22+b3.M23]
	movq mm7, qword [edx + 40]    ;  [   M10    M11      M26    M27]
	pmaddwd mm6, mm0             ;  [a0.M08+a1.M09 | b0.M24+b1.M25]
	paddd mm2, mm3               ;  [ out0 | out1 ]
	pmaddwd mm7, mm1             ;  [a0.M10+a1.M11 | b0.M26+b1.M27]
	psrad mm2, DCT_MMX_ROW_SHIFT_1
	pmaddwd mm0, qword [edx + 48] ;  [a0.M12+a1.M13 | b0.M28+b1.M29]
	paddd mm4, mm5               ;  [ out2 | out3 ]
	pmaddwd mm1, qword [edx + 56] ;  [a0.M14+a1.M15 | b0.M30+b1.M31]
	psrad mm4, DCT_MMX_ROW_SHIFT_1

	paddd mm6, mm7               ;  [ out4 | out5 ]
	movq mm3, [ecx + 0+16]         ; mm3 = [0123]
	psrad mm6, DCT_MMX_ROW_SHIFT_1
	paddd mm0, mm1               ;  [ out6 | out7 ]
	movd mm1, [ecx + 8 + 4+16]     ; [67..]
	psrad mm0, DCT_MMX_ROW_SHIFT_1

	packssdw mm2, mm4            ;  [ out0|out1|out2|out3 ]
	movq mm7, mm3
	pmulhw mm2, [eax + 0]             ;  weight
	packssdw mm6, mm0            ;  [ out4|out5|out6|out7 ]
	punpcklwd mm1, [ecx + 8+16]      ; [6475]
	pmulhw mm6, [eax + 8]             ;  weight

	add edx, 64

	movq mm5, mm1
	psrlq mm1, 32                ; [75..]
	movq [ecx + 0], mm2
	punpcklwd mm1,mm5            ; [7654]

	movq [ecx + 8], mm6
	paddsw mm3, mm1              ; mm3 = [a0 a1 a2 a3]
	psubsw mm7, mm1              ; mm7 = [b0 b1 b2 b3]

	movq mm1, mm3
	punpckldq mm3, mm7           ; mm3 = [a0 a1 b0 b1]
	punpckhdq mm1, mm7           ; mm1 = [b2 b3 a2 a3]

	movq mm5, qword [edx + 0]     ;  [   M00    M01      M16    M17]
	movq mm0, qword [edx + 8]     ;  [   M02    M03      M18    M19]
	pmaddwd mm5, mm3             ;  [a0.M00+a1.M01 | b0.M16+b1.M17]
	movq mm4, qword [edx + 16]    ;  [   M04    M05      M20    M21]
	pmaddwd mm0, mm1             ;  [a2.M02+a3.M03 | b2.M18+b3.M19]
	movq mm2, qword [edx + 24]    ;  [   M06    M07      M22    M23]
	pmaddwd mm4, mm3             ;  [a0.M04+a1.M05 | b0.M20+b1.M21]
	movq mm6, qword [edx + 32]    ;  [   M08    M09      M24    M25]
	pmaddwd mm2, mm1             ;  [a2.M06+a3.M07 | b2.M22+b3.M23]
	movq mm7, qword [edx + 40]    ;  [   M10    M11      M26    M27]
	pmaddwd mm6, mm3             ;  [a0.M08+a1.M09 | b0.M24+b1.M25]
	paddd mm5, mm0               ;  [ out0 | out1 ]
	pmaddwd mm7, mm1             ;  [a0.M10+a1.M11 | b0.M26+b1.M27]
	psrad mm5, DCT_MMX_ROW_SHIFT_1
	pmaddwd mm3, qword [edx + 48] ;  [a0.M12+a1.M13 | b0.M28+b1.M29]
	paddd mm4, mm2               ;  [ out2 | out3 ]
	pmaddwd mm1, qword [edx + 56] ;  [a0.M14+a1.M15 | b0.M30+b1.M31]
	psrad mm4, DCT_MMX_ROW_SHIFT_1

	paddd mm6, mm7               ;  [ out4 | out5 ]
	movq mm0, [ecx+32 + 0]         ; mm0 = [0123]
	psrad mm6, DCT_MMX_ROW_SHIFT_1
	paddd mm3, mm1               ;  [ out6 | out7 ]
	movd mm1, [ecx+32 + 8 + 4]     ; [67..]
	psrad mm3, DCT_MMX_ROW_SHIFT_1

	packssdw mm5, mm4            ;  [ out0|out1|out2|out3 ]
	movq mm7, mm0
	pmulhw mm5, [eax +16]             ;  weight
	packssdw mm6, mm3            ;  [ out4|out5|out6|out7 ]
	punpcklwd mm1, [ecx+32 + 8]      ; [6475]
	pmulhw mm6, [eax +24]             ;  weight

	add edx, 64

	movq mm2, mm1
	psrlq mm1, 32                ; [75..]
	movq [ecx+16], mm5
	punpcklwd mm1,mm2            ; [7654]

	movq [ecx+24], mm6
	paddsw mm0, mm1              ; mm0 = [a0 a1 a2 a3]
	psubsw mm7, mm1              ; mm7 = [b0 b1 b2 b3]

	movq mm1, mm0
	punpckldq mm0, mm7           ; mm0 = [a0 a1 b0 b1]
	punpckhdq mm1, mm7           ; mm1 = [b2 b3 a2 a3]

	movq mm2, qword [edx + 0]     ;  [   M00    M01      M16    M17]
	movq mm3, qword [edx + 8]     ;  [   M02    M03      M18    M19]
	pmaddwd mm2, mm0             ;  [a0.M00+a1.M01 | b0.M16+b1.M17]
	movq mm4, qword [edx + 16]    ;  [   M04    M05      M20    M21]
	pmaddwd mm3, mm1             ;  [a2.M02+a3.M03 | b2.M18+b3.M19]
	movq mm5, qword [edx + 24]    ;  [   M06    M07      M22    M23]
	pmaddwd mm4, mm0             ;  [a0.M04+a1.M05 | b0.M20+b1.M21]
	movq mm6, qword [edx + 32]    ;  [   M08    M09      M24    M25]
	pmaddwd mm5, mm1             ;  [a2.M06+a3.M07 | b2.M22+b3.M23]
	movq mm7, qword [edx + 40]    ;  [   M10    M11      M26    M27]
	pmaddwd mm6, mm0             ;  [a0.M08+a1.M09 | b0.M24+b1.M25]
	paddd mm2, mm3               ;  [ out0 | out1 ]
	pmaddwd mm7, mm1             ;  [a0.M10+a1.M11 | b0.M26+b1.M27]
	psrad mm2, DCT_MMX_ROW_SHIFT_1
	pmaddwd mm0, qword [edx + 48] ;  [a0.M12+a1.M13 | b0.M28+b1.M29]
	paddd mm4, mm5               ;  [ out2 | out3 ]
	pmaddwd mm1, qword [edx + 56] ;  [a0.M14+a1.M15 | b0.M30+b1.M31]
	psrad mm4, DCT_MMX_ROW_SHIFT_1

	paddd mm6, mm7               ;  [ out4 | out5 ]
	movq mm3, [ecx+48]         ; mm3 = [0123]
	psrad mm6, DCT_MMX_ROW_SHIFT_1
	paddd mm0, mm1               ;  [ out6 | out7 ]
	movd mm1, [ecx+48 + 8 + 4]     ; [67..]
	psrad mm0, DCT_MMX_ROW_SHIFT_1

	packssdw mm2, mm4            ;  [ out0|out1|out2|out3 ]
	movq mm7, mm3
	pmulhw mm2, [eax+32]             ;  weight
	packssdw mm6, mm0            ;  [ out4|out5|out6|out7 ]
	punpcklwd mm1, [ecx+48 + 8]      ; [6475]
	pmulhw mm6, [eax+40]             ;  weight

	add edx, 64

	movq mm5, mm1
	psrlq mm1, 32                ; [75..]
	movq [ecx+32 + 0], mm2
	punpcklwd mm1,mm5            ; [7654]

	movq [ecx+32 + 8], mm6
	paddsw mm3, mm1              ; mm3 = [a0 a1 a2 a3]
	psubsw mm7, mm1              ; mm7 = [b0 b1 b2 b3]

	movq mm1, mm3
	punpckldq mm3, mm7           ; mm3 = [a0 a1 b0 b1]
	punpckhdq mm1, mm7           ; mm1 = [b2 b3 a2 a3]

	movq mm5, qword [edx + 0]     ;  [   M00    M01      M16    M17]
	movq mm0, qword [edx + 8]     ;  [   M02    M03      M18    M19]
	pmaddwd mm5, mm3             ;  [a0.M00+a1.M01 | b0.M16+b1.M17]
	movq mm4, qword [edx + 16]    ;  [   M04    M05      M20    M21]
	pmaddwd mm0, mm1             ;  [a2.M02+a3.M03 | b2.M18+b3.M19]
	movq mm2, qword [edx + 24]    ;  [   M06    M07      M22    M23]
	pmaddwd mm4, mm3             ;  [a0.M04+a1.M05 | b0.M20+b1.M21]
	movq mm6, qword [edx + 32]    ;  [   M08    M09      M24    M25]
	pmaddwd mm2, mm1             ;  [a2.M06+a3.M07 | b2.M22+b3.M23]
	movq mm7, qword [edx + 40]    ;  [   M10    M11      M26    M27]
	pmaddwd mm6, mm3             ;  [a0.M08+a1.M09 | b0.M24+b1.M25]
	paddd mm5, mm0               ;  [ out0 | out1 ]
	pmaddwd mm7, mm1             ;  [a0.M10+a1.M11 | b0.M26+b1.M27]
	psrad mm5, DCT_MMX_ROW_SHIFT_1
	pmaddwd mm3, qword [edx + 48] ;  [a0.M12+a1.M13 | b0.M28+b1.M29]
	paddd mm4, mm2               ;  [ out2 | out3 ]
	pmaddwd mm1, qword [edx + 56] ;  [a0.M14+a1.M15 | b0.M30+b1.M31]
	psrad mm4, DCT_MMX_ROW_SHIFT_1

	paddd mm6, mm7               ;  [ out4 | out5 ]
	movq mm0, [ecx+64 + 0]         ; mm0 = [0123]
	psrad mm6, DCT_MMX_ROW_SHIFT_1
	paddd mm3, mm1               ;  [ out6 | out7 ]
	movd mm1, [ecx+64 + 8 + 4]     ; [67..]
	psrad mm3, DCT_MMX_ROW_SHIFT_1
	movq mm7, mm0

	packssdw mm5, mm4            ;  [ out0|out1|out2|out3 ]
	punpcklwd mm1, [ecx+64 + 8]      ; [6475]
	add edx, 64
	pmulhw mm5, [eax+48]             ;  weight
	packssdw mm6, mm3            ;  [ out4|out5|out6|out7 ]
	movq mm2, mm1
	pmulhw mm6, [eax+56]             ;  weight

	movq mm3, qword [edx + 8]     ;  [   M02    M03      M18    M19]

	psrlq mm1, 32                ; [75..]
	movq [ecx+32+16 ], mm5
	punpcklwd mm1,mm2            ; [7654]

	movq [ecx+32+16 +8], mm6
	paddsw mm0, mm1              ; mm0 = [a0 a1 a2 a3]
	psubsw mm7, mm1              ; mm7 = [b0 b1 b2 b3]

	movq mm1, mm0
	punpckldq mm0, mm7           ; mm0 = [a0 a1 b0 b1]
	movq mm2, qword [edx + 0]     ;  [   M00    M01      M16    M17]
	punpckhdq mm1, mm7           ; mm1 = [b2 b3 a2 a3]

	pmaddwd mm2, mm0             ;  [a0.M00+a1.M01 | b0.M16+b1.M17]
	movq mm4, qword [edx + 16]    ;  [   M04    M05      M20    M21]
	pmaddwd mm3, mm1             ;  [a2.M02+a3.M03 | b2.M18+b3.M19]
	movq mm5, qword [edx + 24]    ;  [   M06    M07      M22    M23]
	pmaddwd mm4, mm0             ;  [a0.M04+a1.M05 | b0.M20+b1.M21]
	movq mm6, qword [edx + 32]    ;  [   M08    M09      M24    M25]
	pmaddwd mm5, mm1             ;  [a2.M06+a3.M07 | b2.M22+b3.M23]
	movq mm7, qword [edx + 40]    ;  [   M10    M11      M26    M27]
	pmaddwd mm6, mm0             ;  [a0.M08+a1.M09 | b0.M24+b1.M25]
	paddd mm2, mm3               ;  [ out0 | out1 ]
	pmaddwd mm7, mm1             ;  [a0.M10+a1.M11 | b0.M26+b1.M27]
	psrad mm2, DCT_MMX_ROW_SHIFT_1
	pmaddwd mm0, qword [edx + 48] ;  [a0.M12+a1.M13 | b0.M28+b1.M29]
	paddd mm4, mm5               ;  [ out2 | out3 ]
	pmaddwd mm1, qword [edx + 56] ;  [a0.M14+a1.M15 | b0.M30+b1.M31]
	psrad mm4, DCT_MMX_ROW_SHIFT_1

	paddd mm6, mm7               ;  [ out4 | out5 ]
	movq mm3, [ecx+64 + 0+16]         ; mm3 = [0123]
	psrad mm6, DCT_MMX_ROW_SHIFT_1
	paddd mm0, mm1               ;  [ out6 | out7 ]
	movd mm1, [ecx+64 + 8 + 4+16]     ; [67..]
	psrad mm0, DCT_MMX_ROW_SHIFT_1

	packssdw mm2, mm4            ;  [ out0|out1|out2|out3 ]
	movq mm7, mm3
	pmulhw mm2, [eax+64 + 0]             ;  weight
	packssdw mm6, mm0            ;  [ out4|out5|out6|out7 ]
	punpcklwd mm1, [ecx+64 + 8+16]      ; [6475]
	pmulhw mm6, [eax+64 + 8]             ;  weight

	add edx, 64

	movq mm5, mm1
	psrlq mm1, 32                ; [75..]
	movq [ecx+64 + 0], mm2
	punpcklwd mm1,mm5            ; [7654]

	movq [ecx+64 + 8], mm6
	paddsw mm3, mm1              ; mm3 = [a0 a1 a2 a3]
	psubsw mm7, mm1              ; mm7 = [b0 b1 b2 b3]

	movq mm1, mm3
	punpckldq mm3, mm7           ; mm3 = [a0 a1 b0 b1]
	punpckhdq mm1, mm7           ; mm1 = [b2 b3 a2 a3]

	movq mm5, qword [edx + 0]     ;  [   M00    M01      M16    M17]
	movq mm0, qword [edx + 8]     ;  [   M02    M03      M18    M19]
	pmaddwd mm5, mm3             ;  [a0.M00+a1.M01 | b0.M16+b1.M17]
	movq mm4, qword [edx + 16]    ;  [   M04    M05      M20    M21]
	pmaddwd mm0, mm1             ;  [a2.M02+a3.M03 | b2.M18+b3.M19]
	movq mm2, qword [edx + 24]    ;  [   M06    M07      M22    M23]
	pmaddwd mm4, mm3             ;  [a0.M04+a1.M05 | b0.M20+b1.M21]
	movq mm6, qword [edx + 32]    ;  [   M08    M09      M24    M25]
	pmaddwd mm2, mm1             ;  [a2.M06+a3.M07 | b2.M22+b3.M23]
	movq mm7, qword [edx + 40]    ;  [   M10    M11      M26    M27]
	pmaddwd mm6, mm3             ;  [a0.M08+a1.M09 | b0.M24+b1.M25]
	paddd mm5, mm0               ;  [ out0 | out1 ]
	pmaddwd mm7, mm1             ;  [a0.M10+a1.M11 | b0.M26+b1.M27]
	psrad mm5, DCT_MMX_ROW_SHIFT_1
	pmaddwd mm3, qword [edx + 48] ;  [a0.M12+a1.M13 | b0.M28+b1.M29]
	paddd mm4, mm2               ;  [ out2 | out3 ]
	pmaddwd mm1, qword [edx + 56] ;  [a0.M14+a1.M15 | b0.M30+b1.M31]
	psrad mm4, DCT_MMX_ROW_SHIFT_1

	paddd mm6, mm7               ;  [ out4 | out5 ]
	movq mm0, [ecx+64+32 + 0]         ; mm0 = [0123]
	psrad mm6, DCT_MMX_ROW_SHIFT_1
	paddd mm3, mm1               ;  [ out6 | out7 ]
	movd mm1, [ecx+64+32 + 8 + 4]     ; [67..]
	psrad mm3, DCT_MMX_ROW_SHIFT_1

	packssdw mm5, mm4            ;  [ out0|out1|out2|out3 ]
	movq mm7, mm0
	pmulhw mm5, [eax+64 +16]             ;  weight
	packssdw mm6, mm3            ;  [ out4|out5|out6|out7 ]
	punpcklwd mm1, [ecx+64+32 + 8]      ; [6475]
	pmulhw mm6, [eax+64 +24]             ;  weight

	add edx, 64

	movq mm2, mm1
	psrlq mm1, 32                ; [75..]
	movq [ecx+64+16], mm5
	punpcklwd mm1,mm2            ; [7654]

	movq [ecx+64+24], mm6
	paddsw mm0, mm1              ; mm0 = [a0 a1 a2 a3]
	psubsw mm7, mm1              ; mm7 = [b0 b1 b2 b3]

	movq mm1, mm0
	punpckldq mm0, mm7           ; mm0 = [a0 a1 b0 b1]
	punpckhdq mm1, mm7           ; mm1 = [b2 b3 a2 a3]

	movq mm2, qword [edx + 0]     ;  [   M00    M01      M16    M17]
	movq mm3, qword [edx + 8]     ;  [   M02    M03      M18    M19]
	pmaddwd mm2, mm0             ;  [a0.M00+a1.M01 | b0.M16+b1.M17]
	movq mm4, qword [edx + 16]    ;  [   M04    M05      M20    M21]
	pmaddwd mm3, mm1             ;  [a2.M02+a3.M03 | b2.M18+b3.M19]
	movq mm5, qword [edx + 24]    ;  [   M06    M07      M22    M23]
	pmaddwd mm4, mm0             ;  [a0.M04+a1.M05 | b0.M20+b1.M21]
	movq mm6, qword [edx + 32]    ;  [   M08    M09      M24    M25]
	pmaddwd mm5, mm1             ;  [a2.M06+a3.M07 | b2.M22+b3.M23]
	movq mm7, qword [edx + 40]    ;  [   M10    M11      M26    M27]
	pmaddwd mm6, mm0             ;  [a0.M08+a1.M09 | b0.M24+b1.M25]
	paddd mm2, mm3               ;  [ out0 | out1 ]
	pmaddwd mm7, mm1             ;  [a0.M10+a1.M11 | b0.M26+b1.M27]
	psrad mm2, DCT_MMX_ROW_SHIFT_1
	pmaddwd mm0, qword [edx + 48] ;  [a0.M12+a1.M13 | b0.M28+b1.M29]
	paddd mm4, mm5               ;  [ out2 | out3 ]
	pmaddwd mm1, qword [edx + 56] ;  [a0.M14+a1.M15 | b0.M30+b1.M31]
	psrad mm4, DCT_MMX_ROW_SHIFT_1

	paddd mm6, mm7               ;  [ out4 | out5 ]
	movq mm3, [ecx+64+32+16]         ; mm3 = [0123]
	psrad mm6, DCT_MMX_ROW_SHIFT_1
	paddd mm0, mm1               ;  [ out6 | out7 ]
	movd mm1, [ecx+64+32+16 + 8 + 4]     ; [67..]
	psrad mm0, DCT_MMX_ROW_SHIFT_1

	packssdw mm2, mm4            ;  [ out0|out1|out2|out3 ]
	movq mm7, mm3
	pmulhw mm2, [eax+64+32]             ;  weight
	packssdw mm6, mm0            ;  [ out4|out5|out6|out7 ]
	punpcklwd mm1, [ecx+64+32+16 + 8]      ; [6475]
	pmulhw mm6, [eax+64+40]             ;  weight

	add edx, 64

	movq mm5, mm1
	psrlq mm1, 32                ; [75..]
	movq [ecx+64+32 + 0], mm2
	punpcklwd mm1,mm5            ; [7654]

	movq [ecx+64+32 + 8], mm6
	paddsw mm3, mm1              ; mm3 = [a0 a1 a2 a3]
	psubsw mm7, mm1              ; mm7 = [b0 b1 b2 b3]

	movq mm1, mm3
	punpckldq mm3, mm7           ; mm3 = [a0 a1 b0 b1]
	punpckhdq mm1, mm7           ; mm1 = [b2 b3 a2 a3]

	movq mm5, qword [edx + 0]     ;  [   M00    M01      M16    M17]
	movq mm0, qword [edx + 8]     ;  [   M02    M03      M18    M19]
	pmaddwd mm5, mm3             ;  [a0.M00+a1.M01 | b0.M16+b1.M17]
	movq mm4, qword [edx + 16]    ;  [   M04    M05      M20    M21]
	pmaddwd mm0, mm1             ;  [a2.M02+a3.M03 | b2.M18+b3.M19]
	movq mm2, qword [edx + 24]    ;  [   M06    M07      M22    M23]
	pmaddwd mm4, mm3             ;  [a0.M04+a1.M05 | b0.M20+b1.M21]
	movq mm6, qword [edx + 32]    ;  [   M08    M09      M24    M25]
	pmaddwd mm2, mm1             ;  [a2.M06+a3.M07 | b2.M22+b3.M23]
	movq mm7, qword [edx + 40]    ;  [   M10    M11      M26    M27]
	pmaddwd mm6, mm3             ;  [a0.M08+a1.M09 | b0.M24+b1.M25]
	paddd mm5, mm0               ;  [ out0 | out1 ]
	pmaddwd mm7, mm1             ;  [a0.M10+a1.M11 | b0.M26+b1.M27]
	psrad mm5, DCT_MMX_ROW_SHIFT_1
	pmaddwd mm3, qword [edx + 48] ;  [a0.M12+a1.M13 | b0.M28+b1.M29]
	paddd mm4, mm2               ;  [ out2 | out3 ]
	pmaddwd mm1, qword [edx + 56] ;  [a0.M14+a1.M15 | b0.M30+b1.M31]
	psrad mm4, DCT_MMX_ROW_SHIFT_1

	paddd mm6, mm7               ;  [ out4 | out5 ]
	psrad mm6, DCT_MMX_ROW_SHIFT_1
	paddd mm3, mm1               ;  [ out6 | out7 ]
	psrad mm3, DCT_MMX_ROW_SHIFT_1

	packssdw mm5, mm4            ;  [ out0|out1|out2|out3 ]
	pmulhw mm5, [eax+64+48]             ;  weight
	packssdw mm6, mm3            ;  [ out4|out5|out6|out7 ]
	pmulhw mm6, [eax+64+56]             ;  weight

	movq [ecx+64+32+16 ], mm5
	movq [ecx+64+32+16 +8], mm6

%ifndef NO_EMMS_AT_FUNCTION_END
	emms;
%endif

	ret


;-----------------------------------------------------------------------------
; extern "C" void dct_248_weighted_mmx_ad( short *in, short *out );
;-----------------------------------------------------------------------------
%define DCT248_MMX_ROW_SHIFT_1 17

cglobal dct_248_weighted_mmx_ad

%define x0 (eax + 0*16)
%define x1 (eax + 1*16)
%define x2 (eax + 2*16)
%define x3 (eax + 3*16)
%define x4 (eax + 4*16)
%define x5 (eax + 5*16)
%define x6 (eax + 6*16)
%define x7 (eax + 7*16)
%define y0 (ecx + 0*16)
%define y1 (ecx + 1*16)
%define y2 (ecx + 2*16)
%define y3 (ecx + 3*16)
%define y4 (ecx + 4*16)
%define y5 (ecx + 5*16)
%define y6 (ecx + 6*16)
%define y7 (ecx + 7*16)

dct_248_weighted_mmx_ad:
; in and out can be the same adress!
	mov eax, [esp+4]		; in
	mov ecx, [esp+8]		; out
	lea edx, [pw_tan8]

; col 1
ALIGN 16
	movq mm0, [x0]
	movq mm6, [x6]
	movq mm1, [x1]
	paddw mm0, mm6		; u0
	movq mm7, [x7]
	movq mm2, [x2]
	paddw mm1, mm7		; u1
	movq mm4, [x4]
	movq mm7, mm1		; u1
	movq mm3, [x3]
	paddw mm2, mm4		; u2
	movq mm5, [x5]
	paddw mm1, mm0		; z0 = u0 + u1

	paddw mm3, mm5		; u3
	psubw mm0, mm7		; z2 = u0 - u1

	movq mm5, mm2		; u2
	paddw mm2, mm3		; z1 = u2 + u3
	psubw mm5, mm3		; z3 = u2 - u3

	movq mm7, mm1		; z0
	paddw mm1, mm2		; y0 = z0 + z1
	psubw mm7, mm2		; y2 = z0 - z1

	movq mm3, mm0		; z2
	movq mm2, [x2]
	psubw mm3, mm5		; y6 = z2 - z3
	paddw mm5, mm0		; y4 = z2 + z3

	movq mm0, [x0]

	movq [y0], mm1
	psubw mm0, mm6		; u4 = x0 - x6
	movq [y2], mm7
	psubw mm2, mm4		; u6 = x2 - x4
	movq [y4], mm5
	movq mm6, mm0		; u4
	movq [y6], mm3

	movq mm1, [x1]
	movq mm7, [x7]
	psubw mm1, mm7		; u5 = x1 - x7
	movq mm5, [x5]

	paddw mm0, mm1		; z4 = u4 + u5
	movq mm3, [x3]
	psubw mm6, mm1		; z6 = u4 - u5
	psubw mm3, mm5		; u7 = x3 - x5

	movq mm7, mm2		; u6
	paddw mm2, mm3		; z5 = u6 + u7
	psubw mm7, mm3		; z7 = u6 - u7

	movq mm4, [edx]
	movq mm5, mm2		; z5
	pmulhw mm2, mm4		; z5*w

	paddw mm2, mm0		; y1 = z5*w + z4		
	pmulhw mm0, mm4		; z4*w
	movq [y1], mm2
	psubw mm0, mm5		; y3 = z4*w - z5		

	movq mm1, mm7		; z7
	movq [y3], mm0
	pmulhw mm7, mm4		; z7*w
	movq mm0, [x0+8]
	paddw mm7, mm6		; y5 = z7*w + z6		

	pmulhw mm6, mm4		; z6*w
	movq [y5], mm7
	psubw mm6, mm1		; y7 = z6*w - z7		

	movq [y7], mm6

;  col 2
	movq mm6, [x6+8]
	movq mm1, [x1+8]
	paddw mm0, mm6		; u0
	movq mm7, [x7+8]
	movq mm2, [x2+8]
	paddw mm1, mm7		; u1
	movq mm4, [x4+8]
	movq mm7, mm1		; u1
	movq mm3, [x3+8]
	paddw mm2, mm4		; u2
	movq mm5, [x5+8]
	paddw mm1, mm0		; z0 = u0 + u1

	paddw mm3, mm5		; u3
	psubw mm0, mm7		; z2 = u0 - u1

	movq mm5, mm2		; u2
	paddw mm2, mm3		; z1 = u2 + u3
	psubw mm5, mm3		; z3 = u2 - u3

	movq mm7, mm1		; z0
	paddw mm1, mm2		; y0 = z0 + z1
	psubw mm7, mm2		; y2 = z0 - z1

	movq mm3, mm0		; z2
	movq mm2, [x2+8]
	psubw mm3, mm5		; y6 = z2 - z3
	paddw mm5, mm0		; y4 = z2 + z3

	movq mm0, [x0+8]

	movq [y0+8], mm1
	psubw mm0, mm6		; u4 = x0 - x6
	movq [y2+8], mm7
	psubw mm2, mm4		; u6 = x2 - x4
	movq [y4+8], mm5
	movq mm6, mm0		; u4
	movq [y6+8], mm3

	movq mm1, [x1+8]
	movq mm7, [x7+8]
	psubw mm1, mm7		; u5 = x1 - x7
	movq mm5, [x5+8]

	paddw mm0, mm1		; z4 = u4 + u5
	movq mm3, [x3+8]
	psubw mm6, mm1		; z6 = u4 - u5
	psubw mm3, mm5		; u7 = x3 - x5

	movq mm7, mm2		; u6
	paddw mm2, mm3		; z5 = u6 + u7
	psubw mm7, mm3		; z7 = u6 - u7

	movq mm4, [edx]
	movq mm5, mm2		; z5
	pmulhw mm2, mm4		; z5*w

	paddw mm2, mm0		; y1 = z5*w + z4		
	pmulhw mm0, mm4		; z4*w
	movq [y1+8], mm2
	psubw mm0, mm5		; y3 = z4*w - z5		

	movq mm1, mm7		; z7
	movq [y3+8], mm0
	pmulhw mm7, mm4		; z7*w
	paddw mm7, mm6		; y5 = z7*w + z6		

	pmulhw mm6, mm4		; z6*w
	movq [y5+8], mm7
	psubw mm6, mm1		; y7 = z6*w - z7		

	movq [y7+8], mm6

; now, row processing
	lea eax, [weight_248]

	movd mm1, [ecx + 8 + 4]   ; [0076]
	lea edx, [DCT_248_table]

	movq mm6, [ecx + 8]		; [7654]

	movq mm0, [ecx + 0]		; [3210]
	punpcklwd mm1, mm6		;      [5746]
	movq mm7, mm0
	movq mm2, mm1
	psrlq mm1, 32                ; [0057]
	movq mm3, [edx + 8]			 ;  [   M02    M03      M18    M19]
	punpcklwd mm1,mm2            ; [4567]
	movq mm2, [edx + 0]     ;  [   M00    M01      M16    M17]
	paddsw mm0, mm1              ; mm0 = [a0 a1 a2 a3]
	psubsw mm7, mm1              ; mm7 = [b0 b1 b2 b3]
	movq mm1, mm0
	punpckldq mm0, mm7           ; mm0 = [a0 a1 b0 b1]
	punpckhdq mm1, mm7           ; mm1 = [b2 b3 a2 a3]
	pmaddwd mm2, mm0             ;  [a0.M00+a1.M01 | b0.M16+b1.M17]
	movq mm4, [edx + 16]		 ;  [   M04    M05      M20    M21]
	pmaddwd mm3, mm1             ;  [a2.M02+a3.M03 | b2.M18+b3.M19]
	movq mm5, [edx + 24]		 ;  [   M06    M07      M22    M23]
	pmaddwd mm4, mm0             ;  [a0.M04+a1.M05 | b0.M20+b1.M21]
	movq mm6, [edx + 32]		 ;  [   M08    M09      M24    M25]
	pmaddwd mm5, mm1             ;  [a2.M06+a3.M07 | b2.M22+b3.M23]
	movq mm7, [edx + 40]		 ;  [   M10    M11      M26    M27]
	pmaddwd mm6, mm0             ;  [a0.M08+a1.M09 | b0.M24+b1.M25]
	paddd mm2, mm3               ;  [ out0 | out1 ]
	pmaddwd mm7, mm1             ;  [a0.M10+a1.M11 | b0.M26+b1.M27]
	movq mm3, [edx + 48]
	psrad mm2, DCT248_MMX_ROW_SHIFT_1
	pmaddwd mm0, mm3			 ;  [a0.M12+a1.M13 | b0.M28+b1.M29]
	movq mm3, [edx + 56]
	paddd mm4, mm5               ;  [ out2 | out3 ]
	pmaddwd mm1, mm3			 ;  [a0.M14+a1.M15 | b0.M30+b1.M31]
	psrad mm4, DCT248_MMX_ROW_SHIFT_1
	paddd mm6, mm7               ;  [ out4 | out5 ]
	packssdw mm2, mm4            ;  [ out0|out1|out2|out3 ]
	psrad mm6, DCT248_MMX_ROW_SHIFT_1
	paddd mm0, mm1               ;  [ out6 | out7 ]
	movq mm3, [eax]
	psrad mm0, DCT248_MMX_ROW_SHIFT_1
	movq mm4, [eax+8]
	packssdw mm6, mm0            ;  [ out4|out5|out6|out7 ]
	movd mm1, [ecx + 8 + 4 + 16]   ; [0076]
	pmulhw mm2, mm3				 ;  weight
	movq mm5, [ecx + 8 + 16]		; [7654]
	movq mm7, [ecx + 0 + 16]		; [3210]
	pmulhw mm6, mm4              ;  weight

	punpcklwd mm1, mm5		;      [5746]
	movq [ecx + 0], mm2
	movq mm2, mm1
	psrlq mm1, 32                ; [0057]
	movq mm0, mm7
	punpcklwd mm1,mm2            ; [4567]
	movq mm3, [edx + 8+64]			 ;  [   M02    M03      M18    M19]
	paddsw mm7, mm1              ; mm7 = [a0 a1 a2 a3]
	psubsw mm0, mm1              ; mm0 = [b0 b1 b2 b3]
	movq mm1, mm7
	punpckldq mm7, mm0           ; mm7 = [a0 a1 b0 b1]
	movq mm2, [edx + 0 +64]     ;  [   M00    M01      M16    M17]
	punpckhdq mm1, mm0           ; mm1 = [b2 b3 a2 a3]
	movq [ecx + 8], mm6
	pmaddwd mm2, mm7             ;  [a0.M00+a1.M01 | b0.M16+b1.M17]
	movq mm4, [edx + 16+64]		 ;  [   M04    M05      M20    M21]
	pmaddwd mm3, mm1             ;  [a2.M02+a3.M03 | b2.M18+b3.M19]
	movq mm6, [edx + 24+64]		 ;  [   M06    M07      M22    M23]
	pmaddwd mm4, mm7             ;  [a0.M04+a1.M05 | b0.M20+b1.M21]
	movq mm5, [edx + 32+64]		 ;  [   M08    M09      M24    M25]
	pmaddwd mm6, mm1             ;  [a2.M06+a3.M07 | b2.M22+b3.M23]
	movq mm0, [edx + 40+64]		 ;  [   M10    M11      M26    M27]
	pmaddwd mm5, mm7             ;  [a0.M08+a1.M09 | b0.M24+b1.M25]
	paddd mm2, mm3               ;  [ out0 | out1 ]
	pmaddwd mm0, mm1             ;  [a0.M10+a1.M11 | b0.M26+b1.M27]
	movq mm3, [edx + 48+64]
	psrad mm2, DCT248_MMX_ROW_SHIFT_1
	pmaddwd mm7, mm3			 ;  [a0.M12+a1.M13 | b0.M28+b1.M29]
	movq mm3, [edx + 56+64]
	paddd mm4, mm6               ;  [ out2 | out3 ]
	pmaddwd mm1, mm3		 ;  [a0.M14+a1.M15 | b0.M30+b1.M31]
	psrad mm4, DCT248_MMX_ROW_SHIFT_1
	paddd mm5, mm0               ;  [ out4 | out5 ]
	packssdw mm2, mm4            ;  [ out0|out1|out2|out3 ]
	add ecx, 32
	psrad mm5, DCT248_MMX_ROW_SHIFT_1
	paddd mm7, mm1               ;  [ out6 | out7 ]
	movq mm3, [eax+16]
	psrad mm7, DCT248_MMX_ROW_SHIFT_1
	movq mm4, [eax+24]
	packssdw mm5, mm7            ;  [ out4|out5|out6|out7 ]
	paddsw mm2,	[pw_correction]		; correction
	movd mm1, [ecx + 8 + 4]   ; [0076]
	pmulhw mm2, mm3				 ;  weight
	movq mm6, [ecx + 8]		; [7654]
	pmulhw mm5, mm4              ;  weight
	movq mm0, [ecx + 0]		; [3210]

	punpcklwd mm1, mm6		;      [5746]
	movq mm7, mm0
	movq [ecx + 0+16 - 32], mm2
	movq mm2, mm1
	psrlq mm1, 32                ; [0057]
	movq mm3, [edx + 8]			 ;  [   M02    M03      M18    M19]
	punpcklwd mm1,mm2            ; [4567]
	movq mm2, [edx + 0]     ;  [   M00    M01      M16    M17]
	paddsw mm0, mm1              ; mm0 = [a0 a1 a2 a3]
	psubsw mm7, mm1              ; mm7 = [b0 b1 b2 b3]
	movq mm1, mm0
	punpckldq mm0, mm7           ; mm0 = [a0 a1 b0 b1]
	movq [ecx + 8+16 - 32], mm5
	punpckhdq mm1, mm7           ; mm1 = [b2 b3 a2 a3]
	pmaddwd mm2, mm0             ;  [a0.M00+a1.M01 | b0.M16+b1.M17]
	movq mm4, [edx + 16]		 ;  [   M04    M05      M20    M21]
	pmaddwd mm3, mm1             ;  [a2.M02+a3.M03 | b2.M18+b3.M19]
	movq mm5, [edx + 24]		 ;  [   M06    M07      M22    M23]
	pmaddwd mm4, mm0             ;  [a0.M04+a1.M05 | b0.M20+b1.M21]
	movq mm6, [edx + 32]		 ;  [   M08    M09      M24    M25]
	pmaddwd mm5, mm1             ;  [a2.M06+a3.M07 | b2.M22+b3.M23]
	movq mm7, [edx + 40]		 ;  [   M10    M11      M26    M27]
	pmaddwd mm6, mm0             ;  [a0.M08+a1.M09 | b0.M24+b1.M25]
	paddd mm2, mm3               ;  [ out0 | out1 ]
	pmaddwd mm7, mm1             ;  [a0.M10+a1.M11 | b0.M26+b1.M27]
	movq mm3, [edx + 48]
	psrad mm2, DCT248_MMX_ROW_SHIFT_1
	pmaddwd mm0, mm3			 ;  [a0.M12+a1.M13 | b0.M28+b1.M29]
	movq mm3, [edx + 56]
	paddd mm4, mm5               ;  [ out2 | out3 ]
	pmaddwd mm1, mm3			 ;  [a0.M14+a1.M15 | b0.M30+b1.M31]
	psrad mm4, DCT248_MMX_ROW_SHIFT_1
	paddd mm6, mm7               ;  [ out4 | out5 ]
	packssdw mm2, mm4            ;  [ out0|out1|out2|out3 ]
	psrad mm6, DCT248_MMX_ROW_SHIFT_1
	paddd mm0, mm1               ;  [ out6 | out7 ]
	movq mm3, [eax+32]
	psrad mm0, DCT248_MMX_ROW_SHIFT_1
	movq mm4, [eax+40]
	packssdw mm6, mm0            ;  [ out4|out5|out6|out7 ]
	movd mm1, [ecx + 8 + 4 + 16]   ; [0076]
	pmulhw mm2, mm3				 ;  weight
	movq mm5, [ecx + 8 + 16]		; [7654]
	pmulhw mm6, mm4              ;  weight
	movq mm7, [ecx + 0 + 16]		; [3210]
	punpcklwd mm1, mm5		;      [5746]
	movq [ecx + 0], mm2
	movq mm2, mm1
	psrlq mm1, 32                ; [0057]
	movq mm0, mm7
	punpcklwd mm1,mm2            ; [4567]
	movq mm3, [edx + 8+64]			 ;  [   M02    M03      M18    M19]
	paddsw mm7, mm1              ; mm7 = [a0 a1 a2 a3]
	psubsw mm0, mm1              ; mm0 = [b0 b1 b2 b3]
	movq mm1, mm7
	punpckldq mm7, mm0           ; mm7 = [a0 a1 b0 b1]
	movq mm2, [edx + 0 +64]     ;  [   M00    M01      M16    M17]
	punpckhdq mm1, mm0           ; mm1 = [b2 b3 a2 a3]
	movq [ecx + 8], mm6
	pmaddwd mm2, mm7             ;  [a0.M00+a1.M01 | b0.M16+b1.M17]
	movq mm4, [edx + 16+64]		 ;  [   M04    M05      M20    M21]
	pmaddwd mm3, mm1             ;  [a2.M02+a3.M03 | b2.M18+b3.M19]
	movq mm6, [edx + 24+64]		 ;  [   M06    M07      M22    M23]
	pmaddwd mm4, mm7             ;  [a0.M04+a1.M05 | b0.M20+b1.M21]
	movq mm5, [edx + 32+64]		 ;  [   M08    M09      M24    M25]
	pmaddwd mm6, mm1             ;  [a2.M06+a3.M07 | b2.M22+b3.M23]
	movq mm0, [edx + 40+64]		 ;  [   M10    M11      M26    M27]
	pmaddwd mm5, mm7             ;  [a0.M08+a1.M09 | b0.M24+b1.M25]
	paddd mm2, mm3               ;  [ out0 | out1 ]
	pmaddwd mm0, mm1             ;  [a0.M10+a1.M11 | b0.M26+b1.M27]
	movq mm3, [edx + 48+64]
	psrad mm2, DCT248_MMX_ROW_SHIFT_1
	pmaddwd mm7, mm3			 ;  [a0.M12+a1.M13 | b0.M28+b1.M29]
	movq mm3, [edx + 56+64]
	paddd mm4, mm6               ;  [ out2 | out3 ]
	pmaddwd mm1, mm3		 ;  [a0.M14+a1.M15 | b0.M30+b1.M31]
	psrad mm4, DCT248_MMX_ROW_SHIFT_1
	paddd mm5, mm0               ;  [ out4 | out5 ]
	packssdw mm2, mm4            ;  [ out0|out1|out2|out3 ]
	add ecx, 32
	psrad mm5, DCT248_MMX_ROW_SHIFT_1
	paddd mm7, mm1               ;  [ out6 | out7 ]
	movq mm3, [eax+48]
	psrad mm7, DCT248_MMX_ROW_SHIFT_1
	movq mm4, [eax+56]
	packssdw mm5, mm7            ;  [ out4|out5|out6|out7 ]
	paddsw mm2,	[pw_correction]		; correction
	movd mm1, [ecx + 8 + 4]   ; [0076]
	pmulhw mm2, mm3				 ;  weight
	movq mm6, [ecx + 8]		; [7654]
	pmulhw mm5, mm4              ;  weight
	movq mm0, [ecx + 0]		; [3210]
	movq [ecx + 0+16 - 32], mm2

	punpcklwd mm1, mm6		;      [5746]
	movq mm7, mm0
	movq mm2, mm1
	psrlq mm1, 32                ; [0057]
	movq mm3, [edx + 8]			 ;  [   M02    M03      M18    M19]
	punpcklwd mm1,mm2            ; [4567]
	movq mm2, [edx + 0]     ;  [   M00    M01      M16    M17]
	paddsw mm0, mm1              ; mm0 = [a0 a1 a2 a3]
	psubsw mm7, mm1              ; mm7 = [b0 b1 b2 b3]
	movq mm1, mm0
	punpckldq mm0, mm7           ; mm0 = [a0 a1 b0 b1]
	movq [ecx + 8+16 - 32], mm5
	punpckhdq mm1, mm7           ; mm1 = [b2 b3 a2 a3]
	pmaddwd mm2, mm0             ;  [a0.M00+a1.M01 | b0.M16+b1.M17]
	movq mm4, [edx + 16]		 ;  [   M04    M05      M20    M21]
	pmaddwd mm3, mm1             ;  [a2.M02+a3.M03 | b2.M18+b3.M19]
	movq mm5, [edx + 24]		 ;  [   M06    M07      M22    M23]
	pmaddwd mm4, mm0             ;  [a0.M04+a1.M05 | b0.M20+b1.M21]
	movq mm6, [edx + 32]		 ;  [   M08    M09      M24    M25]
	pmaddwd mm5, mm1             ;  [a2.M06+a3.M07 | b2.M22+b3.M23]
	movq mm7, [edx + 40]		 ;  [   M10    M11      M26    M27]
	pmaddwd mm6, mm0             ;  [a0.M08+a1.M09 | b0.M24+b1.M25]
	paddd mm2, mm3               ;  [ out0 | out1 ]
	pmaddwd mm7, mm1             ;  [a0.M10+a1.M11 | b0.M26+b1.M27]
	movq mm3, [edx + 48]
	psrad mm2, DCT248_MMX_ROW_SHIFT_1
	pmaddwd mm0, mm3			 ;  [a0.M12+a1.M13 | b0.M28+b1.M29]
	movq mm3, [edx + 56]
	paddd mm4, mm5               ;  [ out2 | out3 ]
	pmaddwd mm1, mm3			 ;  [a0.M14+a1.M15 | b0.M30+b1.M31]
	psrad mm4, DCT248_MMX_ROW_SHIFT_1
	paddd mm6, mm7               ;  [ out4 | out5 ]
	packssdw mm2, mm4            ;  [ out0|out1|out2|out3 ]
	psrad mm6, DCT248_MMX_ROW_SHIFT_1
	paddd mm0, mm1               ;  [ out6 | out7 ]
	movq mm3, [eax+64]
	psrad mm0, DCT248_MMX_ROW_SHIFT_1
	movq mm4, [eax+72]
	packssdw mm6, mm0            ;  [ out4|out5|out6|out7 ]
	movd mm1, [ecx + 8 + 4 + 16]   ; [0076]
	pmulhw mm2, mm3				 ;  weight
	movq mm5, [ecx + 8 + 16]		; [7654]
	pmulhw mm6, mm4              ;  weight
	movq mm7, [ecx + 0 + 16]		; [3210]

	punpcklwd mm1, mm5		;      [5746]
	movq [ecx + 0], mm2
	movq mm2, mm1
	psrlq mm1, 32                ; [0057]
	movq mm0, mm7
	punpcklwd mm1,mm2            ; [4567]
	movq mm3, [edx + 8+64]			 ;  [   M02    M03      M18    M19]
	paddsw mm7, mm1              ; mm7 = [a0 a1 a2 a3]
	psubsw mm0, mm1              ; mm0 = [b0 b1 b2 b3]
	movq mm1, mm7
	punpckldq mm7, mm0           ; mm7 = [a0 a1 b0 b1]
	movq mm2, [edx + 0 +64]     ;  [   M00    M01      M16    M17]
	punpckhdq mm1, mm0           ; mm1 = [b2 b3 a2 a3]
	movq [ecx + 8], mm6
	pmaddwd mm2, mm7             ;  [a0.M00+a1.M01 | b0.M16+b1.M17]
	movq mm4, [edx + 16+64]		 ;  [   M04    M05      M20    M21]
	pmaddwd mm3, mm1             ;  [a2.M02+a3.M03 | b2.M18+b3.M19]
	movq mm6, [edx + 24+64]		 ;  [   M06    M07      M22    M23]
	pmaddwd mm4, mm7             ;  [a0.M04+a1.M05 | b0.M20+b1.M21]
	movq mm5, [edx + 32+64]		 ;  [   M08    M09      M24    M25]
	pmaddwd mm6, mm1             ;  [a2.M06+a3.M07 | b2.M22+b3.M23]
	movq mm0, [edx + 40+64]		 ;  [   M10    M11      M26    M27]
	pmaddwd mm5, mm7             ;  [a0.M08+a1.M09 | b0.M24+b1.M25]
	paddd mm2, mm3               ;  [ out0 | out1 ]
	pmaddwd mm0, mm1             ;  [a0.M10+a1.M11 | b0.M26+b1.M27]
	movq mm3, [edx + 48+64]
	psrad mm2, DCT248_MMX_ROW_SHIFT_1
	pmaddwd mm7, mm3			 ;  [a0.M12+a1.M13 | b0.M28+b1.M29]
	movq mm3, [edx + 56+64]
	paddd mm4, mm6               ;  [ out2 | out3 ]
	pmaddwd mm1, mm3		 ;  [a0.M14+a1.M15 | b0.M30+b1.M31]
	psrad mm4, DCT248_MMX_ROW_SHIFT_1
	paddd mm5, mm0               ;  [ out4 | out5 ]
	packssdw mm2, mm4            ;  [ out0|out1|out2|out3 ]
	add ecx, 32
	psrad mm5, DCT248_MMX_ROW_SHIFT_1
	paddd mm7, mm1               ;  [ out6 | out7 ]
	movq mm3, [eax+80]
	psrad mm7, DCT248_MMX_ROW_SHIFT_1
	movq mm4, [eax+88]
	packssdw mm5, mm7            ;  [ out4|out5|out6|out7 ]
	paddsw mm2,	[pw_correction]		; correction
	movd mm1, [ecx + 8 + 4]   ; [0076]
	pmulhw mm2, mm3				 ;  weight
	movq mm6, [ecx + 8]		; [7654]
	pmulhw mm5, mm4              ;  weight
	movq mm0, [ecx + 0]		; [3210]
	movq mm7, mm0

	punpcklwd mm1, mm6		;      [5746]
	movq [ecx + 0+16 - 32], mm2
	movq mm2, mm1
	psrlq mm1, 32                ; [0057]
	movq mm3, [edx + 8]			 ;  [   M02    M03      M18    M19]
	punpcklwd mm1,mm2            ; [4567]
	movq mm2, [edx + 0]     ;  [   M00    M01      M16    M17]
	paddsw mm0, mm1              ; mm0 = [a0 a1 a2 a3]
	psubsw mm7, mm1              ; mm7 = [b0 b1 b2 b3]
	movq mm1, mm0
	punpckldq mm0, mm7           ; mm0 = [a0 a1 b0 b1]
	movq [ecx + 8+16 - 32], mm5
	punpckhdq mm1, mm7           ; mm1 = [b2 b3 a2 a3]
	pmaddwd mm2, mm0             ;  [a0.M00+a1.M01 | b0.M16+b1.M17]
	movq mm4, [edx + 16]		 ;  [   M04    M05      M20    M21]
	pmaddwd mm3, mm1             ;  [a2.M02+a3.M03 | b2.M18+b3.M19]
	movq mm5, [edx + 24]		 ;  [   M06    M07      M22    M23]
	pmaddwd mm4, mm0             ;  [a0.M04+a1.M05 | b0.M20+b1.M21]
	movq mm6, [edx + 32]		 ;  [   M08    M09      M24    M25]
	pmaddwd mm5, mm1             ;  [a2.M06+a3.M07 | b2.M22+b3.M23]
	movq mm7, [edx + 40]		 ;  [   M10    M11      M26    M27]
	pmaddwd mm6, mm0             ;  [a0.M08+a1.M09 | b0.M24+b1.M25]
	paddd mm2, mm3               ;  [ out0 | out1 ]
	pmaddwd mm7, mm1             ;  [a0.M10+a1.M11 | b0.M26+b1.M27]
	movq mm3, [edx + 48]
	psrad mm2, DCT248_MMX_ROW_SHIFT_1
	pmaddwd mm0, mm3			 ;  [a0.M12+a1.M13 | b0.M28+b1.M29]
	movq mm3, [edx + 56]
	paddd mm4, mm5               ;  [ out2 | out3 ]
	pmaddwd mm1, mm3			 ;  [a0.M14+a1.M15 | b0.M30+b1.M31]
	psrad mm4, DCT248_MMX_ROW_SHIFT_1
	paddd mm6, mm7               ;  [ out4 | out5 ]
	packssdw mm2, mm4            ;  [ out0|out1|out2|out3 ]
	psrad mm6, DCT248_MMX_ROW_SHIFT_1
	paddd mm0, mm1               ;  [ out6 | out7 ]
	movq mm3, [eax+96]
	psrad mm0, DCT248_MMX_ROW_SHIFT_1
	movq mm4, [eax+104]
	packssdw mm6, mm0            ;  [ out4|out5|out6|out7 ]
	movd mm1, [ecx + 8 + 4 + 16]   ; [0076]
	pmulhw mm2, mm3				 ;  weight
	movq mm5, [ecx + 8 + 16]		; [7654]
	pmulhw mm6, mm4              ;  weight
	movq mm7, [ecx + 0 + 16]		; [3210]
	punpcklwd mm1, mm5		;      [5746]
	movq [ecx + 0], mm2
	movq mm2, mm1
	psrlq mm1, 32                ; [0057]
	movq mm0, mm7
	punpcklwd mm1,mm2            ; [4567]
	movq mm3, [edx + 8+64]			 ;  [   M02    M03      M18    M19]
	paddsw mm7, mm1              ; mm7 = [a0 a1 a2 a3]
	psubsw mm0, mm1              ; mm0 = [b0 b1 b2 b3]
	movq mm1, mm7
	punpckldq mm7, mm0           ; mm7 = [a0 a1 b0 b1]
	movq mm2, [edx + 0 +64]     ;  [   M00    M01      M16    M17]
	punpckhdq mm1, mm0           ; mm1 = [b2 b3 a2 a3]
	movq [ecx + 8], mm6
	pmaddwd mm2, mm7             ;  [a0.M00+a1.M01 | b0.M16+b1.M17]
	movq mm4, [edx + 16+64]		 ;  [   M04    M05      M20    M21]
	pmaddwd mm3, mm1             ;  [a2.M02+a3.M03 | b2.M18+b3.M19]
	movq mm6, [edx + 24+64]		 ;  [   M06    M07      M22    M23]
	pmaddwd mm4, mm7             ;  [a0.M04+a1.M05 | b0.M20+b1.M21]
	movq mm5, [edx + 32+64]		 ;  [   M08    M09      M24    M25]
	pmaddwd mm6, mm1             ;  [a2.M06+a3.M07 | b2.M22+b3.M23]
	movq mm0, [edx + 40+64]		 ;  [   M10    M11      M26    M27]
	pmaddwd mm5, mm7             ;  [a0.M08+a1.M09 | b0.M24+b1.M25]
	paddd mm2, mm3               ;  [ out0 | out1 ]
	pmaddwd mm0, mm1             ;  [a0.M10+a1.M11 | b0.M26+b1.M27]
	movq mm3, [edx + 48+64]
	psrad mm2, DCT248_MMX_ROW_SHIFT_1
	pmaddwd mm7, mm3			 ;  [a0.M12+a1.M13 | b0.M28+b1.M29]
	movq mm3, [edx + 56+64]
	paddd mm4, mm6               ;  [ out2 | out3 ]
	pmaddwd mm1, mm3		 ;  [a0.M14+a1.M15 | b0.M30+b1.M31]
	psrad mm4, DCT248_MMX_ROW_SHIFT_1
	paddd mm5, mm0               ;  [ out4 | out5 ]
	packssdw mm2, mm4            ;  [ out0|out1|out2|out3 ]
	add ecx, 32
	psrad mm5, DCT248_MMX_ROW_SHIFT_1
	paddd mm7, mm1               ;  [ out6 | out7 ]
	movq mm3, [eax+112]
	psrad mm7, DCT248_MMX_ROW_SHIFT_1
	movq mm4, [eax+120]
	paddsw mm2,	[pw_correction]		; correction
	packssdw mm5, mm7            ;  [ out4|out5|out6|out7 ]
	pmulhw mm2, mm3				 ;  weight
	pmulhw mm5, mm4              ;  weight
	movq [ecx + 0+16 - 32], mm2
	movq [ecx + 8+16 - 32], mm5

%ifndef NO_EMMS_AT_FUNCTION_END
	emms;
%endif

	ret





