/******************************************************************************/
/*                                                                            */
/*  Cedocida DV-Codec                                                         */
/*                                                                            */
/*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              */
/*  Project start: 15.12.2003                                                 */
/*  Last change  : 22.05.2005                                                 */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  This program is free software; you can redistribute it and/or modify      */
/*  it under the terms of the GNU General Public License as published by      */
/*  the Free Software Foundation; either version 2 of the License, or         */
/*  (at your option) any later version.                                       */
/*                                                                            */
/*  This program is distributed in the hope that it will be useful,           */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/*  GNU General Public License for more details.                              */
/*                                                                            */
/*  You should have received a copy of the GNU General Public License         */
/*  along with this program; if not, write to the Free Software               */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                            */
/******************************************************************************/


#define EMMS_ASM __asm { emms; };


void byte_swap_block80_asm( void *blk, unsigned int N );

void weighting_block( short *in, short *out, short *weight );
void weighting_block_MMX( short *in, short *out, short *weight );

void multiply_block( short *in, short *out, short *k );
void multiply_block_MMX( short *in, short *out, short *k );

void weighting_clipping( short *in, short *out, short *weight );
void weighting_clipping_MMX( short *in, short *out, short *weight );
void weighting_clipping_SSE( short *in, short *out, short *weight );

void coring( short *block, short *core_positive_negative, unsigned int N );
void coring_MMX( short *block, short *core_positive_negative, unsigned int N );

void copy_YUY2_to_MBYUV422( unsigned int *in, short *out, int stride );
void copy_YUY2_to_MBYUV422_MMX( unsigned int *in, short *out, int stride );
void copy_YUY2_to_MBYVU420( unsigned int *in, short *out, int stride );
void copy_YUY2_to_MBYVU420_MMX( unsigned int *in, short *out, int stride );

void copy_YUY2_to_MBYVU420_12bit_MMX( unsigned int *in, short *out, int stride );

int is_interlaced( short *block );
int is_interlaced_MMX( short *block, short threshold  );

int max_abs_AC( short *block );
int max_abs_AC_MMX( short *block );

int get_abs_AC70( short *block );
int get_abs_AC70_MMX( short *block );



// the following is not testet yet!


void coring_weighting_clipping( short *in, short *out, short *core_positive_negative, short *weight );
void coring_weighting_clipping_MMX( short *in, short *out, short *core_positive_negative, short *weight );
void coring_weighting_clipping_SSE( short *in, short *out, short *core_positive_negative, short *weight );

int sum_overflow_MMX( short *block, short *limit_positive_negative );
int max_sqr_AC_high_MMX( short *block );
int sum_sqr_AC_MMX( short *block );


void clear_block128_asm( void *blk, unsigned int N );
void clear_block80_asm( void *in, unsigned int N );
void ones_block80_asm( void *in, unsigned int N );

void multiply_clip4095_MMX( short *in, short *out, short *k );
void multiply_clip_16bit( short *in, short *out, short *k );
void multiply_clip_16bit_MMX( short *in, short *out, short *k );

void multiply_clip_14bit( short *in, short *out, short *k );
void multiply_clip_14bit_MMX( short *in, short *out, short *k );

void copy_YV12_to_MBYVU420_12bit( unsigned char *src_y, unsigned char *src_u, unsigned char *src_v, short int *dst, unsigned int stride_y, unsigned int stride_uv );



void copy_YV12_to_MBYVU411border_12bit( unsigned char *src_y, unsigned char *src_u, unsigned char *src_v, short int *dst, unsigned int stride_y, unsigned int stride_uv );
void copy_YV12_to_MBYVU411_12bit( unsigned char *src_y, unsigned char *src_u, unsigned char *src_v, short int *dst, unsigned int stride_y, unsigned int stride_uv );
void copy_YUY2_to_MBYVU411border_12bit( unsigned int *in, short *out, int stride );
void copy_YUY2_to_MBYVU411_12bit( unsigned int *in, short *out, int stride, int isFirstCol );
